using System;

namespace NFC.Mifare_DESFire
{
    public enum APDUStatusCodes : UInt16
    {
        OPERATION_OK            = 0x9000, // =  Successful operation
        NO_CHANGES              = 0x900C, // =  No changes done to backup files, CommitTransaction / AbortTransaction not necessary
        OUT_OF_EEPROM_ERROR     = 0x900E, // =  Insufficient NV-Memory to complete command
        ILLEGAL_COMMAND_CODE    = 0x901C, // =  Command code not supported
        INTEGRITY_ERROR         = 0x901E, // =  CRC or MAC does not match data Padding bytes not valid
        NO_SUCH_KEY             = 0x9040, // =  Invalid key number specified
        LENGTH_ERROR            = 0x907E, // =  Length of command string invalid
        PERMISSION_DENIED       = 0x909D, // =  Current configuration / status does not allow the requested command
        PARAMETER_ERROR         = 0x909E, // =  Value of the parameter(s) invalid
        APPLICATION_NOT_FOUND   = 0x90A0, // =  Requested AID not present on PICC
        APPL_INTEGRITY_ERROR    = 0x90A1, // =  Unrecoverable error within application, application will be disabled
        AUTHENTICATION_ERROR    = 0x90AE, // =  Current authentication status does not allow the requested command
        ADDITIONAL_FRAME        = 0x90AF, // =  Additional data frame is expected to be sent
        BOUNDARY_ERROR          = 0x90BE, // =  Attempt to read/write data from/to beyond the file\'s/record\'s limits. Attempt to exceed the limits of a value file.
        PICC_INTEGRITY_ERROR    = 0x90C1, // =  Unrecoverable error within PICC, PICC will be disabled
        COMMAND_ABORTED         = 0x90CA, // =  Previous Command was not fully completed Not all Frames were requested or provided by the PCD
        PICC_DISABLED_ERROR     = 0x90CD, // =  PICC was disabled by an unrecoverable error
        COUNT_ERROR             = 0x90CE, // =  Number of Applications limited to 28, no additional CreateApplication possible
        DUPLICATE_ERROR         = 0x90DE, // =  Creation of file/application failed because file/application with same number already exists
        EEPROM_ERROR            = 0x90EE, // =  Could not complete NV-write operation due to loss of power, internal backup/rollback mechanism activated
        FILE_NOT_FOUND          = 0x90F0, // =  Specified file number does not exist
        FILE_INTEGRITY_ERROR    = 0x90F1, // =  Unrecoverable error within file, file will be disabled
    }
}