Borepin
===

# Building 

## On Windows
1. Install Visual Studio 2019
    [download Visual Studio](https://visualstudio.microsoft.com/de/)
    * with Xamarin
    * with UWP
    * with .NET Desktop
2. Install GTKSharp for Windows
    [download GTKSharp](https://www.mono-project.com/download/stable/#download-win)
3. Install capnproto

    3.1 If you have Chocolatey installed
    ```shell
    $ choco install capnproto
    ```
    3.2 else you can download it from [here](https://capnproto.org/install.html) and add it to your PATH

4. Clone Borepin
    [download Borepin](https://gitlab.com/fabinfra/fabaccess/client)
6. Load Borepin
7. Build Borepin

If Step 5. Build Borepin is failing because of GTKSharp, it could help to restart your PC.

## Build GTK Project
1. Install mono, gtk-sharp, msbuild, nuget
    1.1 Debian based
    ```shell
    $ apt install mono-complete, gtk-sharp2, nuget, capnproto
    ```
    1.2 ArchLinux based
    ```shell
    $ pacman -S mono, mono-msbuild, gtk-sharp-2, nuget, capnproto
    ```
2. Clone Borepin
    ```shell
    $ git clone https://gitlab.com/fabinfra/fabaccess/client.git
    ```
    
3. Build Borepin
    ```shell
    $ cd client
    $ msbuild -t:Borepin_GTK
    ```
4. Run Borepin
    ```shell
    $ mono ./Borepin/Borepin.GTK/bin/Debug/Borepin.GTK.exe
    ```
You can also use Rider or monodevelop as an IDE for development on Borepin

## Testing
We use [NUnit](https://nunit.org/) for testing.
